const authentication = require('@feathersjs/authentication');
const jwt = require('@feathersjs/authentication-jwt');
const local = require('@feathersjs/authentication-local');
const oauth2 = require('@feathersjs/authentication-oauth2');
const GithubStrategy = require('passport-github');

module.exports = function (chassis) {
  const config = chassis.get('authentication');

  // Set up authentication with the secret
  chassis.configure(authentication(config));
  chassis.configure(jwt());
  chassis.configure(local());

  // app.configure(oauth2(Object.assign({
  //   name: 'github',
  //   Strategy: GithubStrategy
  // }, config.github)));

  // The `authentication` service is used to create a JWT.
  // The before `create` hook registers strategies that can be used
  // to create a new valid JWT (e.g. local or oauth2)
  chassis.service('authentication').hooks({
    before: {
      create: [authentication.hooks.authenticate(config.strategies)],
      remove: [authentication.hooks.authenticate('jwt')]
    }
  });
};
