/* eslint-disable no-console */
process.env.SUPPRESS_NO_CONFIG_WARNING = 'y';
var config = require('config')

// const logger        = require('winston');
const createChassis = require('./chassis');

const init = ( nm, mdl, cnf ) => {

  const chassis = createChassis(nm, mdl, cnf);
  const port    = chassis.get('port');
  const host    = chassis.get('host');
  const name    = chassis.get('name');
  const logger  = chassis.get('service-logger');
  const server  = chassis.listen(port);

  process.on('unhandledRejection', (reason, p) => logger.error('Unhandled Rejection at: Promise ', p, reason));
  server.on('listening', () => logger.log('info', '%s running at http://%s:%d', name, host, port) );

  return chassis;
};

module.exports = init;
