const configurations = {
  //////////////////////////////////////////////////////// ////
  // Host //////////////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  host                  : 'localhost',
  port                  : 3333,
  //////////////////////////////////////////////////////// ////
  // Chassis ///////////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  root                  : true,
  secure                : true,
  cors                  : true,
  compression           : true,
  notfound              : true,
  errors                : true,
  //////////////////////////////////////////////////////// ////
  // Service ///////////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  type                  : 'consumer',
  paginate              : { default: 24, max: 100 },
  sockets               : false,
  //////////////////////////////////////////////////////// ////
  // Authentication ////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  authentication: {
    'strategies': ['jwt','local'],
    'path': '/authentication',
    'service': 'accounts',
    'secret': 'secret1234',
    'jwt': {
      'header': { 'typ': 'access' },
      'audience': 'https://keesee.net',
      'subject': 'anonymous',
      'issuer': 'shuteye',
      'algorithm': 'HS256',
      'expiresIn': '10d'
    },
    'local': {
      'entity': 'account',
      'usernameField': 'email',
      'passwordField': 'password'
    },
    // 'auth0': {
    //   'clientID': 'your auth0 client id',
    //   'clientSecret': 'your auth0 client secret',
    //   'successRedirect': '/',
    //   'domain': 'mydomain.auth0.com'
    // },
    // 'google': {
    //   'clientID': 'your google client id',
    //   'clientSecret': 'your google client secret',
    //   'successRedirect': '/',
    //   'scope': ['profile openid email']
    // },
    // 'facebook': {
    //   'clientID': 'your facebook client id',
    //   'clientSecret': 'your facebook client secret',
    //   'successRedirect': '/',
    //   'scope': ['public_profile','email'],
    //   'profileFields': ['id','displayName','first_name','last_name','email','gender','profileUrl','birthday','picture','permissions']
    // },
    // 'github': {
    //   'clientID': 'your github client id',
    //   'clientSecret': 'your github client secret',
    //   'successRedirect': '/'
    // },
  },

  //////////////////////////////////////////////////////// ////
  // Documentaton //////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  docs                : true,
  docsEndpoint        : '/docs',

  //////////////////////////////////////////////////////// ////
  // Ping Profiling, &  health. ////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  ping                  : false,
  info                  : false,
  health                : false,
  monitoring            : false,
  profiler              : false,
  profilerType          : 'detail',
  pingEndpoint          : '/ping',
  healthEndpoint        : '/health',
  monitoringEndpoint    : '/monitor',
  infoEndpoint          : '/info',

  //////////////////////////////////////////////////////// ////
  // Caching. //////////////////////////////////////////// ////
  //////////////////////////////////////////////////////// ////
  cache                 : false,
  cacheGet              : false,
  cacheFind             : false,
  cacheGetDuration      : 60 * 60,
  cacheFindDuration     : 60 * 60,
  /////////////////////////////////////////////////////// ////
  // Persistance. /////////////////////////////////////// ////
  /////////////////////////////////////////////////////// ////
  store                 : 'mongodb',
  mongoHost             : 'localhost',
  mongoPort             : 27017,
  redis:                { 'host': 'localhost', 'port': 6379 },
  redisCache :          { 'defaultDuration': 3600, 'parseNestedRoutes': true, 'removePathFromCacheKey': false }
};

module.exports = configurations;
