const DefaultSchema = require('../defaults/default.schema')

module.exports = function (chassis) {
  const mongooseClient = chassis.get('mongooseClient');
  const { Schema }  = mongooseClient;
  const mngsFields  = chassis.get('service-model') || DefaultSchema;
  const logger      = chassis.get('service-logger');

  if(!chassis.get('service-model')) {
    logger.warn('No schema provided. A generic one was used.  https://gist.github.com/keesee/bd58a05b5406a4407770e4c9fc5c3737')
  } else {
    logger.info('Model Bootstrapped')
  }

  const service = new Schema(mngsFields, {timestamps: true});
  return mongooseClient.model('service', service);
};
