const mongoose = require('mongoose');

module.exports = function () {
  const chassis = this;
  const host    = chassis.get('mongoHost')  || 'localhost';
  const port    = chassis.get('mongoPort')  || 27017;
  const user    = chassis.get('mongoUser');
  const pass    = chassis.get('mongoPassword');

  const logger  = chassis.get('service-logger');
  const db      = chassis.get('mongoDatabase') || chassis.get('name');
  const CONNECT = `mongodb://${host}:${port}/${db}`;

  mongoose.Promise = global.Promise;
  mongoose.connect(CONNECT, { useMongoClient: true })
    .then(() => { logger.info('Connected to '+ CONNECT); })
    .catch(() => { logger.error('Error Connecting to '+ CONNECT); });

  chassis.set('mongooseClient', mongoose);
};
