// const addAuthHooks  = require('../../utils/addAuthHooks');
// const createService = require('feathers-mongoose');
// const createModel   = require('../../models/core.model');

// module.exports = function () {
//   const chassis   = this;
//   const Model     = createModel(chassis);
//   const paginate  = chassis.get('paginate');
//   const name      = chassis.get('name')
//   const options   = { Model, paginate };
//   let hooks       = chassis.get('service-hooks') || {};

//   chassis.use(`/${name}`, createService(options));
//   const service   = chassis.service(name);

//   if (chassis.get('isAuth')) { hooks = addAuthHooks(hooks); }
//   service.hooks(hooks);

//   if (chassis.get('service-filters')) {
//     service.filter(chassis.get('service-filters'));
//   }
// };

const createService = require('feathers-mongoose');
const createModel   = require('../../models/core.model');
const defaultHooks  = require('../../defaults/default.hooks');

module.exports = function (chassis) {
  const Model     = createModel(chassis);
  const paginate  = chassis.get('paginate');
  const hooks     = chassis.get('service-hooks') || defaultHooks;
  const name      = chassis.get('name');
  const options   = { name: name, Model, paginate };
  const logger    = chassis.get('service-logger');

  if(!chassis.get('service-hooks')) {
    logger.warn('No hooks provided. Generic hooks used.  https://gist.github.com/keesee/5837217fc634d413e1ceeeb923b91423')
  } else {
    logger.info('Hooks Bootstrapped')
  }

  // Initialize our service with any options it requires
  chassis.use('/'+name, createService(options));

  // Get our initialized service so that we can register hooks and filters
  const service = chassis.service(name);
  service.hooks(hooks);
};
