const fieldList = require('../data/fields')

const processFields = function(s) {
  if (!s || typeof s !== 'string') { return ({}) }

  const fields    = s.trim().split(',')
  const rFields   = {}

  fields.forEach(f => {
    let rField        = {}
    let rFieldKey     = null
    const dyConfig    = {}
    let fieldSplit    = f.split('&')
    let fieldTitle    = fieldSplit[0].trim()

    fieldSplit.shift()
    let fieldOptions  = fieldSplit

    fieldOptions.forEach(opt => {
      let optionSplit = opt.split('|')
      dyConfig[optionSplit[0]] = optionSplit[1]
    })

    while (
      fieldTitle.charAt(0) === '*' ||
      fieldTitle.charAt(0) === '!' ||
      fieldTitle.charAt(0) === '#' ||
      fieldTitle.charAt(0) === '^' ||
      fieldTitle.charAt(0) === '@' ||
      fieldTitle.charAt(0) === '-' ||
      fieldTitle.charAt(0) === '~' ||
      fieldTitle.charAt(0) === '$' ||
      fieldTitle.charAt(0) === ';' ||
      fieldTitle.charAt(0) === ':' ){

      if (fieldTitle.charAt(0) === '*') { dyConfig.required   = true }
      if (fieldTitle.charAt(0) === '@') { dyConfig.unique     = true }
      if (fieldTitle.charAt(0) === '-') { dyConfig.lowercase  = true }
      if (fieldTitle.charAt(0) === '#') { dyConfig.trim       = true }
      if (fieldTitle.charAt(0) === '!') { dyConfig.index      = true }
      if (fieldTitle.charAt(0) === '~') { dyConfig.system     = true }
      if (fieldTitle.charAt(0) === '$') { dyConfig.private    = true }
      // if (fieldTitle.charAt(0) === ';') { dyConfig.private    = true }
      // if (fieldTitle.charAt(0) === ':') { dyConfig.private    = true }

      fieldTitle = fieldTitle.substr(1);
    }

    if (fieldList[fieldTitle]) {
      rField              = Object.assign({},fieldList[fieldTitle].config, dyConfig)
      rFieldKey           = dyConfig.as ? dyConfig.as : fieldList[fieldTitle].key
      rFields[rFieldKey]  = rField
    } else {
      console.log(fieldTitle + " isn't an available field.  It was Ignored.")
    }
  })

  return rFields
}

module.exports = processFields
